]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
Merge branch 'master' of git://git.denx.de/u-boot-i2c
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier: GPL-2.0+
7
8 usage()
9 {
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -l, --list List all targets to be built
22 -m, --maintainers List all targets and maintainer email
23 -M, --mails List all targets and all affilated emails
24 -C, --check Enable build checking
25 -n, --continue Continue (skip boards already built)
26 -r, --rebuild-errors Rebuild any boards that errored
27 -h, --help This help output
28
29 Selections by these options are logically ANDed; if the same option
30 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
31 will select all configurations where the vendor is either FOO or
32 BAR. Any additional arguments specified on the command line are
33 always build additionally. See the boards.cfg file for more info.
34
35 If no boards are specified, then the default is "powerpc".
36
37 Environment variables:
38 BUILD_NCPUS number of parallel make jobs (default: auto)
39 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
40 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
41 architecture "ARCH". Substitute "ARCH" for any
42 supported architecture (default: "")
43 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
44 BUILD_DIR output build directory (default: ./)
45 BUILD_NBUILDS number of parallel targets (default: 1)
46
47 Examples:
48 - build all Power Architecture boards:
49 MAKEALL -a powerpc
50 MAKEALL --arch powerpc
51 MAKEALL powerpc
52 - build all PowerPC boards manufactured by vendor "esd":
53 MAKEALL -a powerpc -v esd
54 - build all PowerPC boards manufactured either by "keymile" or "siemens":
55 MAKEALL -a powerpc -v keymile -v siemens
56 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
57 MAKEALL -c mpc83xx -v freescale 4xx
58 EOF
59 exit ${ret}
60 }
61
62 SHORT_OPTS="ha:c:v:s:lmMCnr"
63 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails,check,continue,rebuild-errors"
64
65 # Option processing based on util-linux-2.13/getopt-parse.bash
66
67 # Note that we use `"$@"' to let each command-line parameter expand to a
68 # separate word. The quotes around `$@' are essential!
69 # We need TEMP as the `eval set --' would nuke the return value of
70 # getopt.
71 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
72 -n 'MAKEALL' -- "$@"`
73
74 [ $? != 0 ] && usage 1
75
76 # Note the quotes around `$TEMP': they are essential!
77 eval set -- "$TEMP"
78
79 SELECTED=''
80 ONLY_LIST=''
81 PRINT_MAINTS=''
82 MAINTAINERS_ONLY=''
83 CONTINUE=''
84 REBUILD_ERRORS=''
85
86 while true ; do
87 case "$1" in
88 -a|--arch)
89 # echo "Option ARCH: argument \`$2'"
90 if [ "$opt_a" ] ; then
91 opt_a="${opt_a%)} || \$2 == \"$2\")"
92 else
93 opt_a="(\$2 == \"$2\")"
94 fi
95 SELECTED='y'
96 shift 2 ;;
97 -c|--cpu)
98 # echo "Option CPU: argument \`$2'"
99 if [ "$opt_c" ] ; then
100 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
101 else
102 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
103 fi
104 SELECTED='y'
105 shift 2 ;;
106 -s|--soc)
107 # echo "Option SoC: argument \`$2'"
108 if [ "$opt_s" ] ; then
109 opt_s="${opt_s%)} || \$6 == \"$2\" || \$6 ~ /$2/)"
110 else
111 opt_s="(\$6 == \"$2\" || \$6 ~ /$2/)"
112 fi
113 SELECTED='y'
114 shift 2 ;;
115 -v|--vendor)
116 # echo "Option VENDOR: argument \`$2'"
117 if [ "$opt_v" ] ; then
118 opt_v="${opt_v%)} || \$5 == \"$2\")"
119 else
120 opt_v="(\$5 == \"$2\")"
121 fi
122 SELECTED='y'
123 shift 2 ;;
124 -C|--check)
125 CHECK='C=1'
126 shift ;;
127 -n|--continue)
128 CONTINUE='y'
129 shift ;;
130 -r|--rebuild-errors)
131 REBUILD_ERRORS='y'
132 shift ;;
133 -l|--list)
134 ONLY_LIST='y'
135 shift ;;
136 -m|--maintainers)
137 ONLY_LIST='y'
138 PRINT_MAINTS='y'
139 MAINTAINERS_ONLY='y'
140 shift ;;
141 -M|--mails)
142 ONLY_LIST='y'
143 PRINT_MAINTS='y'
144 shift ;;
145 -h|--help)
146 usage ;;
147 --)
148 shift ; break ;;
149 *)
150 echo "Internal error!" >&2 ; exit 1 ;;
151 esac
152 done
153 # echo "Remaining arguments:"
154 # for arg do echo '--> '"\`$arg'" ; done
155
156 FILTER="\$1 !~ /^#/"
157 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
158 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
159 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
160 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
161
162 if [ "$SELECTED" ] ; then
163 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
164
165 # Make sure some boards from boards.cfg are actually found
166 if [ -z "$SELECTED" ] ; then
167 echo "Error: No boards selected, invalid arguments"
168 exit 1
169 fi
170 fi
171
172 #########################################################################
173
174 # Print statistics when we exit
175 trap exit 1 2 3 15
176 trap print_stats 0
177
178 # Determine number of CPU cores if no default was set
179 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
180
181 if [ "$BUILD_NCPUS" -gt 1 ]
182 then
183 JOBS="-j $((BUILD_NCPUS + 1))"
184 else
185 JOBS=""
186 fi
187
188 if [ "${MAKEALL_LOGDIR}" ] ; then
189 LOG_DIR=${MAKEALL_LOGDIR}
190 else
191 LOG_DIR="LOG"
192 fi
193
194 : ${BUILD_NBUILDS:=1}
195 BUILD_MANY=0
196
197 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
198 BUILD_MANY=1
199 : ${BUILD_DIR:=./build}
200 mkdir -p "${BUILD_DIR}/ERR"
201 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
202 fi
203
204 : ${BUILD_DIR:=.}
205
206 OUTPUT_PREFIX="${BUILD_DIR}"
207
208 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
209 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
210 find "${LOG_DIR}/" -type f -exec rm -f {} +
211 fi
212
213 LIST=""
214
215 # Keep track of the number of builds and errors
216 ERR_CNT=0
217 ERR_LIST=""
218 WRN_CNT=0
219 WRN_LIST=""
220 TOTAL_CNT=0
221 SKIP_CNT=0
222 CURRENT_CNT=0
223 OLDEST_IDX=1
224 RC=0
225
226 # Helper funcs for parsing boards.cfg
227 boards_by_field()
228 {
229 FS="[ \t]+"
230 [ -n "$3" ] && FS="$3"
231 awk \
232 -v field="$1" \
233 -v select="$2" \
234 -F "$FS" \
235 '($1 !~ /^#/ && $field == select) { print $1 }' \
236 boards.cfg
237 }
238 boards_by_arch() { boards_by_field 2 "$@" ; }
239 boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
240 boards_by_soc() { boards_by_field 6 "$@" ; }
241
242 #########################################################################
243 ## MPC5xx Systems
244 #########################################################################
245
246 LIST_5xx="$(boards_by_cpu mpc5xx)"
247
248 #########################################################################
249 ## MPC5xxx Systems
250 #########################################################################
251
252 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
253
254 #########################################################################
255 ## MPC512x Systems
256 #########################################################################
257
258 LIST_512x="$(boards_by_cpu mpc512x)"
259
260 #########################################################################
261 ## MPC8xx Systems
262 #########################################################################
263
264 LIST_8xx="$(boards_by_cpu mpc8xx)"
265
266 #########################################################################
267 ## PPC4xx Systems
268 #########################################################################
269
270 LIST_4xx="$(boards_by_cpu ppc4xx)"
271
272 #########################################################################
273 ## MPC824x Systems
274 #########################################################################
275
276 LIST_824x="$(boards_by_cpu mpc824x)"
277
278 #########################################################################
279 ## MPC8260 Systems (includes 8250, 8255 etc.)
280 #########################################################################
281
282 LIST_8260="$(boards_by_cpu mpc8260)"
283
284 #########################################################################
285 ## MPC83xx Systems (includes 8349, etc.)
286 #########################################################################
287
288 LIST_83xx="$(boards_by_cpu mpc83xx)"
289
290 #########################################################################
291 ## MPC85xx Systems (includes 8540, 8560 etc.)
292 #########################################################################
293
294 LIST_85xx="$(boards_by_cpu mpc85xx)"
295
296 #########################################################################
297 ## MPC86xx Systems
298 #########################################################################
299
300 LIST_86xx="$(boards_by_cpu mpc86xx)"
301
302 #########################################################################
303 ## 74xx/7xx Systems
304 #########################################################################
305
306 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
307
308 #########################################################################
309 ## PowerPC groups
310 #########################################################################
311
312 LIST_TSEC=" \
313 ${LIST_83xx} \
314 ${LIST_85xx} \
315 ${LIST_86xx} \
316 "
317
318 LIST_powerpc=" \
319 ${LIST_5xx} \
320 ${LIST_512x} \
321 ${LIST_5xxx} \
322 ${LIST_8xx} \
323 ${LIST_824x} \
324 ${LIST_8260} \
325 ${LIST_83xx} \
326 ${LIST_85xx} \
327 ${LIST_86xx} \
328 ${LIST_4xx} \
329 ${LIST_74xx_7xx}\
330 "
331
332 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
333 # still using "ppc" instead of "powerpc"
334 LIST_ppc=" \
335 ${LIST_powerpc} \
336 "
337
338 #########################################################################
339 ## StrongARM Systems
340 #########################################################################
341
342 LIST_SA="$(boards_by_cpu sa1100)"
343
344 #########################################################################
345 ## ARM7 Systems
346 #########################################################################
347
348 LIST_ARM7="$(boards_by_cpu arm720t)"
349
350 #########################################################################
351 ## ARM9 Systems
352 #########################################################################
353
354 LIST_ARM9="$(boards_by_cpu arm920t) \
355 $(boards_by_cpu arm926ejs) \
356 $(boards_by_cpu arm925t) \
357 $(boards_by_cpu arm946es) \
358 "
359
360 #########################################################################
361 ## ARM11 Systems
362 #########################################################################
363 LIST_ARM11="$(boards_by_cpu arm1136) \
364 $(boards_by_cpu arm1176) \
365 "
366
367 #########################################################################
368 ## ARMV7 Systems
369 #########################################################################
370
371 LIST_ARMV7="$(boards_by_cpu armv7)"
372
373 #########################################################################
374 ## AT91 Systems
375 #########################################################################
376
377 LIST_at91="$(boards_by_soc at91)"
378
379 #########################################################################
380 ## Xscale Systems
381 #########################################################################
382
383 LIST_pxa="$(boards_by_cpu pxa)"
384
385 LIST_ixp="$(boards_by_cpu ixp)"
386
387 #########################################################################
388 ## SPEAr Systems
389 #########################################################################
390
391 LIST_spear="$(boards_by_soc spear)"
392
393 #########################################################################
394 ## ARM groups
395 #########################################################################
396
397 LIST_arm="$(boards_by_arch arm)"
398
399 #########################################################################
400 ## MIPS Systems (default = big endian)
401 #########################################################################
402
403 LIST_mips4kc=" \
404 incaip \
405 incaip_100MHz \
406 incaip_133MHz \
407 incaip_150MHz \
408 qemu_mips \
409 vct_platinum \
410 vct_platinum_small \
411 vct_platinum_onenand \
412 vct_platinum_onenand_small \
413 vct_platinumavc \
414 vct_platinumavc_small \
415 vct_platinumavc_onenand \
416 vct_platinumavc_onenand_small \
417 vct_premium \
418 vct_premium_small \
419 vct_premium_onenand \
420 vct_premium_onenand_small \
421 "
422
423 LIST_au1xx0=" \
424 dbau1000 \
425 dbau1100 \
426 dbau1500 \
427 dbau1550 \
428 "
429
430 LIST_mips=" \
431 ${LIST_mips4kc} \
432 ${LIST_mips5kc} \
433 ${LIST_au1xx0} \
434 "
435
436 #########################################################################
437 ## MIPS Systems (little endian)
438 #########################################################################
439
440 LIST_au1xx0_el=" \
441 dbau1550_el \
442 pb1000 \
443 "
444 LIST_mips_el=" \
445 ${LIST_au1xx0_el} \
446 "
447 #########################################################################
448 ## OpenRISC Systems
449 #########################################################################
450
451 LIST_openrisc="$(boards_by_arch openrisc)"
452
453 #########################################################################
454 ## x86 Systems
455 #########################################################################
456
457 LIST_x86="$(boards_by_arch x86)"
458
459 #########################################################################
460 ## Nios-II Systems
461 #########################################################################
462
463 LIST_nios2="$(boards_by_arch nios2)"
464
465 #########################################################################
466 ## MicroBlaze Systems
467 #########################################################################
468
469 LIST_microblaze="$(boards_by_arch microblaze)"
470
471 #########################################################################
472 ## ColdFire Systems
473 #########################################################################
474
475 LIST_m68k="$(boards_by_arch m68k)"
476 LIST_coldfire=${LIST_m68k}
477
478 #########################################################################
479 ## AVR32 Systems
480 #########################################################################
481
482 LIST_avr32="$(boards_by_arch avr32)"
483
484 #########################################################################
485 ## Blackfin Systems
486 #########################################################################
487
488 LIST_blackfin="$(boards_by_arch blackfin)"
489
490 #########################################################################
491 ## SH Systems
492 #########################################################################
493
494 LIST_sh2="$(boards_by_cpu sh2)"
495 LIST_sh3="$(boards_by_cpu sh3)"
496 LIST_sh4="$(boards_by_cpu sh4)"
497
498 LIST_sh="$(boards_by_arch sh)"
499
500 #########################################################################
501 ## SPARC Systems
502 #########################################################################
503
504 LIST_sparc="$(boards_by_arch sparc)"
505
506 #########################################################################
507 ## NDS32 Systems
508 #########################################################################
509
510 LIST_nds32="$(boards_by_arch nds32)"
511
512 #-----------------------------------------------------------------------
513
514 get_target_location() {
515 local target=$1
516 local BOARD_NAME=""
517 local CONFIG_NAME=""
518 local board=""
519 local vendor=""
520
521 # Automatic mode
522 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
523
524 if [ -z "${line}" ] ; then echo "" ; return ; fi
525
526 set ${line}
527
528 # add default board name if needed
529 [ $# = 3 ] && set ${line} ${1}
530
531 CONFIG_NAME="${1%_config}"
532
533 [ "${BOARD_NAME}" ] || BOARD_NAME="${1%_config}"
534
535 if [ "$4" = "-" ] ; then
536 board=${BOARD_NAME}
537 else
538 board="$4"
539 fi
540
541 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
542 [ $# -gt 6 ] && [ "$7" != "-" ] && {
543 tmp="${7%:*}"
544 if [ "$tmp" ] ; then
545 CONFIG_NAME="$tmp"
546 fi
547 }
548
549 # Assign board directory to BOARDIR variable
550 if [ -z "${vendor}" ] ; then
551 BOARDDIR=${board}
552 else
553 BOARDDIR=${vendor}/${board}
554 fi
555
556 echo "${CONFIG_NAME}:${BOARDDIR}"
557 }
558
559 get_target_maintainers() {
560 local name=`echo $1 | cut -d : -f 1`
561
562 if ! grep -qsi "[[:blank:]]${name}[[:blank:]]" MAINTAINERS ; then
563 echo ""
564 return ;
565 fi
566
567 local line=`tac MAINTAINERS | grep -ni "[[:blank:]]${name}[[:blank:]]" | cut -d : -f 1`
568 local mail=`tac MAINTAINERS | tail -n +${line} | \
569 sed -n ":start /.*@.*/ { b mail } ; n ; b start ; :mail /.*@.*/ { p ; n ; b mail } ; q" | \
570 sed "s/^.*<//;s/>.*$//"`
571 echo "$mail"
572 }
573
574 get_target_arch() {
575 local target=$1
576
577 # Automatic mode
578 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
579
580 if [ -z "${line}" ] ; then echo "" ; return ; fi
581
582 set ${line}
583 echo "$2"
584 }
585
586 list_target() {
587 if [ "$PRINT_MAINTS" != 'y' ] ; then
588 echo "$1"
589 return
590 fi
591
592 echo -n "$1:"
593
594 local loc=`get_target_location $1`
595
596 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
597
598 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
599
600 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
601
602 local dir=`echo ${loc} | cut -d ":" -f 2`
603 local cfg=`echo ${loc} | cut -d ":" -f 1`
604 local git_result=`git log --format=%aE board/${dir} \
605 include/configs/${cfg}.h | grep "@"`
606 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
607 head -n 3`
608 local git_result_top=`echo ${git_result} | tr " " "\n" | \
609 sort | uniq -c | sort -nr | head -n 3 | \
610 sed "s/^ \+[0-9]\+ \+//"`
611
612 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
613 sort -u | tr "\n" " " | sed "s/ $//" ;
614 else
615 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
616 sed "s/ $//" ;
617 fi
618
619 echo ""
620 }
621
622 # Each finished build will have a file called ${donep}${n},
623 # where n is the index of the build. Each build
624 # we've already noted as finished will have ${skipp}${n}.
625 # The code managing the build process will use this information
626 # to ensure that only BUILD_NBUILDS builds are in flight at once
627 donep="${LOG_DIR}/._done_"
628 skipp="${LOG_DIR}/._skip_"
629
630 build_target_killed() {
631 echo "Aborted $target build."
632 # Remove the logs for this board since it was aborted
633 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
634 exit
635 }
636
637 build_target() {
638 target=$1
639 build_idx=$2
640
641 if [ "$ONLY_LIST" == 'y' ] ; then
642 list_target ${target}
643 return
644 fi
645
646 if [ $BUILD_MANY == 1 ] ; then
647 output_dir="${OUTPUT_PREFIX}/${target}"
648 mkdir -p "${output_dir}"
649 trap build_target_killed TERM
650 else
651 output_dir="${OUTPUT_PREFIX}"
652 fi
653
654 export BUILD_DIR="${output_dir}"
655
656 target_arch=$(get_target_arch ${target})
657 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
658 if [ "${cross_toolchain}" ] ; then
659 MAKE="make CROSS_COMPILE=${cross_toolchain}"
660 elif [ "${CROSS_COMPILE}" ] ; then
661 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
662 else
663 MAKE=make
664 fi
665
666 ${MAKE} distclean >/dev/null
667 ${MAKE} -s ${target}_config
668
669 ${MAKE} ${JOBS} ${CHECK} all \
670 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
671
672 # Check for 'make' errors
673 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
674 RC=1
675 fi
676
677 if [ $BUILD_MANY == 1 ] ; then
678 trap - TERM
679
680 ${MAKE} -s tidy
681
682 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
683 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
684 else
685 rm ${LOG_DIR}/${target}.ERR
686 fi
687 else
688 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
689 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
690 : $(( ERR_CNT += 1 ))
691 ERR_LIST="${ERR_LIST} $target"
692 else
693 : $(( WRN_CNT += 1 ))
694 WRN_LIST="${WRN_LIST} $target"
695 fi
696 else
697 rm ${LOG_DIR}/${target}.ERR
698 fi
699 fi
700
701 OBJS=${output_dir}/u-boot
702 if [ -e ${output_dir}/spl/u-boot-spl ]; then
703 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
704 fi
705
706 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
707
708 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
709
710 touch "${donep}${build_idx}"
711 }
712
713 manage_builds() {
714 search_idx=${OLDEST_IDX}
715 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
716
717 while true; do
718 if [ -e "${donep}${search_idx}" ] ; then
719 : $(( CURRENT_CNT-- ))
720 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
721 : $(( OLDEST_IDX++ ))
722
723 # Only want to count it once
724 rm -f "${donep}${search_idx}"
725 touch "${skipp}${search_idx}"
726 elif [ -e "${skipp}${search_idx}" ] ; then
727 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
728 : $(( OLDEST_IDX++ ))
729 fi
730 : $(( search_idx++ ))
731 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
732 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
733 search_idx=${OLDEST_IDX}
734 sleep 1
735 else
736 break
737 fi
738 fi
739 done
740 }
741
742 build_targets() {
743 for t in "$@" ; do
744 # If a LIST_xxx var exists, use it. But avoid variable
745 # expansion in the eval when a board name contains certain
746 # characters that the shell interprets.
747 case ${t} in
748 *[-+=]*) list= ;;
749 *) list=$(eval echo '${LIST_'$t'}') ;;
750 esac
751 if [ -n "${list}" ] ; then
752 build_targets ${list}
753 else
754 : $((TOTAL_CNT += 1))
755 : $((CURRENT_CNT += 1))
756 rm -f "${donep}${TOTAL_CNT}"
757 rm -f "${skipp}${TOTAL_CNT}"
758 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
759 : $((SKIP_CNT += 1))
760 touch "${donep}${TOTAL_CNT}"
761 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
762 : $((SKIP_CNT += 1))
763 touch "${donep}${TOTAL_CNT}"
764 else
765 if [ $BUILD_MANY == 1 ] ; then
766 build_target ${t} ${TOTAL_CNT} &
767 else
768 CUR_TGT="${t}"
769 build_target ${t} ${TOTAL_CNT}
770 CUR_TGT=''
771 fi
772 fi
773 fi
774
775 # We maintain a running count of all the builds we have done.
776 # Each finished build will have a file called ${donep}${n},
777 # where n is the index of the build. Each build
778 # we've already noted as finished will have ${skipp}${n}.
779 # We track the current index via TOTAL_CNT, and the oldest
780 # index. When we exceed the maximum number of parallel builds,
781 # We look from oldest to current for builds that have completed,
782 # and update the current count and oldest index as appropriate.
783 # If we've gone through the entire list, wait a second, and
784 # reprocess the entire list until we find a build that has
785 # completed
786 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
787 manage_builds
788 fi
789 done
790 }
791
792 #-----------------------------------------------------------------------
793
794 kill_children() {
795 local OS=$(uname -s)
796 local children=""
797 case "${OS}" in
798 "Darwin")
799 # Mac OS X is known to have BSD style ps
800 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
801 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
802 ;;
803 *)
804 # everything else tries the GNU style
805 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
806 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
807 ;;
808 esac
809
810 kill $children 2> /dev/null
811 wait $children 2> /dev/null
812
813 exit
814 }
815
816 print_stats() {
817 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
818
819 # Only count boards that completed
820 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
821
822 rm -f ${donep}* ${skipp}*
823
824 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
825 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
826 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
827 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
828 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
829 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
830 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
831 else
832 # Remove the logs for any board that was interrupted
833 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
834 fi
835
836 : $((TOTAL_CNT -= ${SKIP_CNT}))
837 echo ""
838 echo "--------------------- SUMMARY ----------------------------"
839 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
840 echo "Boards skipped: ${SKIP_CNT}"
841 fi
842 echo "Boards compiled: ${TOTAL_CNT}"
843 if [ ${ERR_CNT} -gt 0 ] ; then
844 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
845 fi
846 if [ ${WRN_CNT} -gt 0 ] ; then
847 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
848 fi
849 echo "----------------------------------------------------------"
850
851 if [ $BUILD_MANY == 1 ] ; then
852 kill_children
853 fi
854
855 exit $RC
856 }
857
858 #-----------------------------------------------------------------------
859
860 # Build target groups selected by options, plus any command line args
861 set -- ${SELECTED} "$@"
862 # run PowerPC by default
863 [ $# = 0 ] && set -- powerpc
864 build_targets "$@"
865 wait